# Fedi Link Fetcher

A pair of PHP scripts that extract links from your Mastodon / snac bookmarks and add them to:

- Read Later in Readeck (simple API token) 
- Watch Later in YouTube Playlist (Google oAUTH API)

## 1. Getting a Readeck token 

In Web UI:

- Settings, API tokens, Create API Token
- Check Bookmarks Read + Write

Save it as:
```
/_credentials/token.json
```

## 2. Getting a Youtube API token

- Go to the Google Cloud Console:
- Project > APIs & Services > Credentials
- Create oauth client ID 
- for TV and limited INPUT
- Download the OAuth 2.0 Client ID JSON file

Save it as:
```
/_credentials/client_secret.json
```

## 3. Add your Google account as a test user

- Go to Google Cloud Console > OAuth consent screen
- ~> Audience
- Under “Test users”
- Add your Google email for your Youtube account


## 4. Download Google API Client with PHP Composer

```
composer require google/apiclient:^2.0
```
## 5. Run command to get (or recreate) a token and create FediList playlist
```
./update_google_token.php
```


## 6. Add the command to your cron to fetch the links regularly
```
*/5 * * * * /home/snac/fedi_slurp/fedi_slurp.php > /home/snac/logs/fedi_slurp.log 2>&1
```



